#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 17 "gram.y"
#include <config.h>
#include <includes.h>
#include <radvd.h>
#include <defaults.h>

extern struct Interface *IfaceList;
struct Interface *iface = NULL;
struct AdvPrefix *prefix = NULL;
struct AdvRoute *route = NULL;
struct AdvRDNSS *rdnss = NULL;

extern char *conf_file;
extern int num_lines;
extern char *yytext;
extern int sock;

static void cleanup(void);
static void yyerror(char *msg);

#if 0 /* no longer necessary? */
#ifndef HAVE_IN6_ADDR_S6_ADDR
# ifdef __FreeBSD__
#  define s6_addr32 __u6_addr.__u6_addr32
#  define s6_addr16 __u6_addr.__u6_addr16
# endif
#endif
#endif

#define ABORT	do { cleanup(); YYABORT; } while (0);

#line 110 "gram.y"
typedef union {
	unsigned int		num;
	int			snum;
	double			dec;
	int			bool;
	struct in6_addr		*addr;
	char			*str;
	struct AdvPrefix	*pinfo;
	struct AdvRoute		*rinfo;
	struct AdvRDNSS		*rdnssinfo;
} YYSTYPE;
#line 65 "gram.c"
#define T_INTERFACE 257
#define T_PREFIX 258
#define T_ROUTE 259
#define T_RDNSS 260
#define STRING 261
#define NUMBER 262
#define SIGNEDNUMBER 263
#define DECIMAL 264
#define SWITCH 265
#define IPV6ADDR 266
#define INFINITY 267
#define T_IgnoreIfMissing 268
#define T_AdvSendAdvert 269
#define T_MaxRtrAdvInterval 270
#define T_MinRtrAdvInterval 271
#define T_MinDelayBetweenRAs 272
#define T_AdvManagedFlag 273
#define T_AdvOtherConfigFlag 274
#define T_AdvLinkMTU 275
#define T_AdvReachableTime 276
#define T_AdvRetransTimer 277
#define T_AdvCurHopLimit 278
#define T_AdvDefaultLifetime 279
#define T_AdvDefaultPreference 280
#define T_AdvSourceLLAddress 281
#define T_AdvOnLink 282
#define T_AdvAutonomous 283
#define T_AdvValidLifetime 284
#define T_AdvPreferredLifetime 285
#define T_AdvRouterAddr 286
#define T_AdvHomeAgentFlag 287
#define T_AdvIntervalOpt 288
#define T_AdvHomeAgentInfo 289
#define T_Base6to4Interface 290
#define T_UnicastOnly 291
#define T_HomeAgentPreference 292
#define T_HomeAgentLifetime 293
#define T_AdvRoutePreference 294
#define T_AdvRouteLifetime 295
#define T_AdvRDNSSPreference 296
#define T_AdvRDNSSOpenFlag 297
#define T_AdvRDNSSLifetime 298
#define T_AdvMobRtrSupportFlag 299
#define T_BAD_TOKEN 300
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   12,   13,    1,   14,   15,   15,    2,    2,
    5,    5,    8,    8,   16,   16,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
    4,    3,   18,   19,   19,   20,   20,   21,   21,   21,
   21,   21,   21,    7,    6,   22,   23,   23,   24,   24,
   25,   25,   10,    9,   28,   28,   29,   26,   27,   27,
   30,   30,   31,   31,   31,   11,   11,
};
short yylen[] = {                                         2,
    2,    1,    5,    2,    1,    4,    0,    1,    0,    1,
    0,    1,    0,    1,    2,    1,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    2,    5,    4,    0,    1,    2,    1,    3,    3,    3,
    3,    3,    3,    2,    5,    4,    0,    1,    2,    1,
    3,    3,    2,    5,    2,    1,    1,    2,    0,    1,
    2,    1,    3,    3,    3,    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    2,    0,    5,    4,    1,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   16,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   10,    0,   15,   23,   24,   18,   21,   17,   20,
   19,   22,   25,   26,   27,   28,   29,   32,   30,   31,
   33,   36,   34,   35,   39,   37,   38,   40,    3,    0,
    0,    0,    0,   12,    0,   41,    0,    0,    0,    0,
    6,    0,   14,    0,   54,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   47,   43,    0,   67,    0,   66,
   63,    0,    0,    0,    0,    0,   60,    0,    0,   76,
   77,    0,    0,    0,    0,    0,   46,   56,   65,    0,
    0,    0,    0,    0,   72,    0,    0,    0,   59,   48,
   49,   51,   52,   50,   53,   42,    0,    0,    0,    0,
   71,   61,   62,   55,   73,   74,   75,   64,
};
short yydgoto[] = {                                       2,
    6,   60,   61,   62,   92,   93,   94,  101,  102,  103,
  132,    3,    4,   30,   31,   32,   33,   63,  113,  114,
  115,   95,  125,  126,  127,  104,  143,  119,  120,  144,
  145,
};
short yysindex[] = {                                   -253,
 -230, -253,    0,  -89,    0,    0,    0, -252, -227, -214,
 -251, -250, -232, -213, -212, -208, -207, -206, -205, -204,
 -203, -202, -201, -200, -199, -198, -194, -193, -195,  -66,
 -197, -252,    0,    3,   12,   13,   14,   15,   16,   17,
   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35, -171, -163,
 -197,    0,  -26,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   51,
 -167, -160, -163,    0,  -22,    0, -240, -159,   55, -162,
    0, -160,    0,  -18,    0, -246, -158, -157, -260, -260,
 -156, -230,  -19, -240,    0,    0, -152,    0, -162,    0,
    0, -288, -151, -260,  -14, -246,    0,   54,   56,    0,
    0,   57,   58,   59,   60,   61,    0,    0,    0, -148,
 -144, -260,   -3, -288,    0,   64,   65,   66,    0,    0,
    0,    0,    0,    0,    0,    0,   67,   68,   69,   70,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0, -125,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -120, -122,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -119,
 -120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    5, -119,    0,    0,    0,    6,    0,    0,    0,
    0,    5,    0,    0,    0,    7,    0,    0,    0,    0,
    0,    0,    0,   36,    0,    0,    0,    0,   37,    0,
    0,   38,    0,    0,    0,  -66,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   39,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   40,   81,    0,    0,   50,    0,    0,   42,    0,    0,
 -109,  143,    0,    0,    0,    0,  114,    0,    0,    0,
   41,    0,    0,    0,   43,    0,    0,    0,   46,    0,
    4,
};
#define YYTABLESIZE 169
short yytable[] = {                                       7,
  133,  130,    8,    1,    9,   11,  131,  140,  141,  142,
   36,   38,   37,   39,  147,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   40,
    5,   41,  159,    8,   23,   24,   25,   34,   26,   27,
   28,  107,  108,  109,  110,  111,   29,  123,  124,  112,
   35,   42,   43,   44,   45,   46,   47,   48,   58,   49,
   59,   65,   50,   51,   52,   53,   54,   55,   56,   57,
   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
   86,   87,   88,   89,   90,   91,   97,   98,   99,  100,
  106,  117,  116,  118,  122,  136,  128,  129,  134,  138,
  148,  146,  150,  157,  151,  152,  153,  154,  155,  156,
  158,  160,  162,  163,  164,  165,  166,  167,  168,   13,
   44,   57,    7,    7,    7,    8,    8,    8,    9,    9,
   11,   96,  105,  121,    7,   64,    0,  161,    0,    0,
    0,  135,    0,    0,  137,    0,    0,    0,    0,   68,
   45,    0,   69,   70,  139,    0,    0,    0,  149,
};
short yycheck[] = {                                     125,
  110,  262,  125,  257,  125,  125,  267,  296,  297,  298,
  262,  262,  264,  264,  124,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  262,
  261,  264,  142,  123,  287,  288,  289,  265,  291,  292,
  293,  282,  283,  284,  285,  286,  299,  294,  295,  290,
  265,  265,  265,  262,  262,  262,  262,  262,  125,  263,
  258,   59,  265,  265,  265,  265,  265,  262,  262,  265,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,  266,  259,  123,   47,  266,  260,
  123,   47,  262,  266,  123,  125,  265,  265,  265,  262,
  125,  263,   59,  262,   59,   59,   59,   59,   59,   59,
  265,  125,   59,   59,   59,   59,   59,   59,   59,  125,
  125,  125,  258,  259,  260,  258,  259,  260,  259,  260,
  260,   61,   93,  102,    2,   32,   -1,  144,   -1,   -1,
   -1,  112,   -1,   -1,  114,   -1,   -1,   -1,   -1,  123,
  125,   -1,  125,  125,  119,   -1,   -1,   -1,  126,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 300
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_INTERFACE",
"T_PREFIX","T_ROUTE","T_RDNSS","STRING","NUMBER","SIGNEDNUMBER","DECIMAL",
"SWITCH","IPV6ADDR","INFINITY","T_IgnoreIfMissing","T_AdvSendAdvert",
"T_MaxRtrAdvInterval","T_MinRtrAdvInterval","T_MinDelayBetweenRAs",
"T_AdvManagedFlag","T_AdvOtherConfigFlag","T_AdvLinkMTU","T_AdvReachableTime",
"T_AdvRetransTimer","T_AdvCurHopLimit","T_AdvDefaultLifetime",
"T_AdvDefaultPreference","T_AdvSourceLLAddress","T_AdvOnLink","T_AdvAutonomous",
"T_AdvValidLifetime","T_AdvPreferredLifetime","T_AdvRouterAddr",
"T_AdvHomeAgentFlag","T_AdvIntervalOpt","T_AdvHomeAgentInfo",
"T_Base6to4Interface","T_UnicastOnly","T_HomeAgentPreference",
"T_HomeAgentLifetime","T_AdvRoutePreference","T_AdvRouteLifetime",
"T_AdvRDNSSPreference","T_AdvRDNSSOpenFlag","T_AdvRDNSSLifetime",
"T_AdvMobRtrSupportFlag","T_BAD_TOKEN",
};
char *yyrule[] = {
"$accept : grammar",
"grammar : grammar ifacedef",
"grammar : ifacedef",
"ifacedef : ifacehead '{' ifaceparams '}' ';'",
"ifacehead : T_INTERFACE name",
"name : STRING",
"ifaceparams : optional_ifacevlist optional_prefixlist optional_routelist optional_rdnsslist",
"optional_ifacevlist :",
"optional_ifacevlist : ifacevlist",
"optional_prefixlist :",
"optional_prefixlist : prefixlist",
"optional_routelist :",
"optional_routelist : routelist",
"optional_rdnsslist :",
"optional_rdnsslist : rdnsslist",
"ifacevlist : ifacevlist ifaceval",
"ifacevlist : ifaceval",
"ifaceval : T_MinRtrAdvInterval NUMBER ';'",
"ifaceval : T_MaxRtrAdvInterval NUMBER ';'",
"ifaceval : T_MinDelayBetweenRAs NUMBER ';'",
"ifaceval : T_MinRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MaxRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MinDelayBetweenRAs DECIMAL ';'",
"ifaceval : T_IgnoreIfMissing SWITCH ';'",
"ifaceval : T_AdvSendAdvert SWITCH ';'",
"ifaceval : T_AdvManagedFlag SWITCH ';'",
"ifaceval : T_AdvOtherConfigFlag SWITCH ';'",
"ifaceval : T_AdvLinkMTU NUMBER ';'",
"ifaceval : T_AdvReachableTime NUMBER ';'",
"ifaceval : T_AdvRetransTimer NUMBER ';'",
"ifaceval : T_AdvDefaultLifetime NUMBER ';'",
"ifaceval : T_AdvDefaultPreference SIGNEDNUMBER ';'",
"ifaceval : T_AdvCurHopLimit NUMBER ';'",
"ifaceval : T_AdvSourceLLAddress SWITCH ';'",
"ifaceval : T_AdvIntervalOpt SWITCH ';'",
"ifaceval : T_AdvHomeAgentInfo SWITCH ';'",
"ifaceval : T_AdvHomeAgentFlag SWITCH ';'",
"ifaceval : T_HomeAgentPreference NUMBER ';'",
"ifaceval : T_HomeAgentLifetime NUMBER ';'",
"ifaceval : T_UnicastOnly SWITCH ';'",
"ifaceval : T_AdvMobRtrSupportFlag SWITCH ';'",
"prefixlist : prefixdef optional_prefixlist",
"prefixdef : prefixhead '{' optional_prefixplist '}' ';'",
"prefixhead : T_PREFIX IPV6ADDR '/' NUMBER",
"optional_prefixplist :",
"optional_prefixplist : prefixplist",
"prefixplist : prefixplist prefixparms",
"prefixplist : prefixparms",
"prefixparms : T_AdvOnLink SWITCH ';'",
"prefixparms : T_AdvAutonomous SWITCH ';'",
"prefixparms : T_AdvRouterAddr SWITCH ';'",
"prefixparms : T_AdvValidLifetime number_or_infinity ';'",
"prefixparms : T_AdvPreferredLifetime number_or_infinity ';'",
"prefixparms : T_Base6to4Interface name ';'",
"routelist : routedef optional_routelist",
"routedef : routehead '{' optional_routeplist '}' ';'",
"routehead : T_ROUTE IPV6ADDR '/' NUMBER",
"optional_routeplist :",
"optional_routeplist : routeplist",
"routeplist : routeplist routeparms",
"routeplist : routeparms",
"routeparms : T_AdvRoutePreference SIGNEDNUMBER ';'",
"routeparms : T_AdvRouteLifetime number_or_infinity ';'",
"rdnsslist : rdnssdef optional_rdnsslist",
"rdnssdef : rdnsshead '{' optional_rdnssplist '}' ';'",
"rdnssaddrs : rdnssaddrs rdnssaddr",
"rdnssaddrs : rdnssaddr",
"rdnssaddr : IPV6ADDR",
"rdnsshead : T_RDNSS rdnssaddrs",
"optional_rdnssplist :",
"optional_rdnssplist : rdnssplist",
"rdnssplist : rdnssplist rdnssparms",
"rdnssplist : rdnssparms",
"rdnssparms : T_AdvRDNSSPreference NUMBER ';'",
"rdnssparms : T_AdvRDNSSOpenFlag SWITCH ';'",
"rdnssparms : T_AdvRDNSSLifetime number_or_infinity ';'",
"number_or_infinity : NUMBER",
"number_or_infinity : INFINITY",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 634 "gram.y"

static
void cleanup(void)
{
	if (iface)
		free(iface);
	
	if (prefix)
		free(prefix);

	if (route)
		free(route);

	if (rdnss)
		free(rdnss);
}

static void
yyerror(char *msg)
{
	cleanup();
	flog(LOG_ERR, "%s in %s, line %d: %s", msg, conf_file, num_lines, yytext);
}
#line 404 "gram.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 129 "gram.y"
{
			struct Interface *iface2;

			iface2 = IfaceList;
			while (iface2)
			{
				if (!strcmp(iface2->Name, iface->Name))
				{
					flog(LOG_ERR, "duplicate interface "
						"definition for %s", iface->Name);
					ABORT;
				}
				iface2 = iface2->next;
			}			

			if (check_device(sock, iface) < 0) {
				if (iface->IgnoreIfMissing) {
					dlog(LOG_DEBUG, 4, "interface %s did not exist, ignoring the interface", iface->Name);
					goto skip_interface;
				}
				else {
					flog(LOG_ERR, "interface %s does not exist", iface->Name);
					ABORT;
				}
			}
			if (setup_deviceinfo(sock, iface) < 0)
				ABORT;
			if (check_iface(iface) < 0)
				ABORT;
			if (setup_linklocal_addr(sock, iface) < 0)
				ABORT;
			if (setup_allrouters_membership(sock, iface) < 0)
				ABORT;

			iface->next = IfaceList;
			IfaceList = iface;

			dlog(LOG_DEBUG, 4, "interface definition for %s is ok", iface->Name);

skip_interface:
			iface = NULL;
		}
break;
case 4:
#line 173 "gram.y"
{
			iface = malloc(sizeof(struct Interface));

			if (iface == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			iface_init_defaults(iface);
			strncpy(iface->Name, yyvsp[0].str, IFNAMSIZ-1);
			iface->Name[IFNAMSIZ-1] = '\0';
		}
break;
case 5:
#line 188 "gram.y"
{
			/* check vality */
			yyval.str = yyvsp[0].str;
		}
break;
case 6:
#line 195 "gram.y"
{
			iface->AdvPrefixList = yyvsp[-2].pinfo;
			iface->AdvRouteList = yyvsp[-1].rinfo;
			iface->AdvRDNSSList = yyvsp[0].rdnssinfo;
		}
break;
case 9:
#line 207 "gram.y"
{
			yyval.pinfo = NULL;
		}
break;
case 11:
#line 214 "gram.y"
{
			yyval.rinfo = NULL;
		}
break;
case 13:
#line 221 "gram.y"
{
			yyval.rdnssinfo = NULL;
		}
break;
case 17:
#line 232 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 18:
#line 236 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 19:
#line 240 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].num;
		}
break;
case 20:
#line 244 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 21:
#line 248 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 22:
#line 252 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].dec;
		}
break;
case 23:
#line 256 "gram.y"
{
			iface->IgnoreIfMissing = yyvsp[-1].bool;
		}
break;
case 24:
#line 260 "gram.y"
{
			iface->AdvSendAdvert = yyvsp[-1].bool;
		}
break;
case 25:
#line 264 "gram.y"
{
			iface->AdvManagedFlag = yyvsp[-1].bool;
		}
break;
case 26:
#line 268 "gram.y"
{
			iface->AdvOtherConfigFlag = yyvsp[-1].bool;
		}
break;
case 27:
#line 272 "gram.y"
{
			iface->AdvLinkMTU = yyvsp[-1].num;
		}
break;
case 28:
#line 276 "gram.y"
{
			iface->AdvReachableTime = yyvsp[-1].num;
		}
break;
case 29:
#line 280 "gram.y"
{
			iface->AdvRetransTimer = yyvsp[-1].num;
		}
break;
case 30:
#line 284 "gram.y"
{
			iface->AdvDefaultLifetime = yyvsp[-1].num;
		}
break;
case 31:
#line 288 "gram.y"
{
			iface->AdvDefaultPreference = yyvsp[-1].snum;
		}
break;
case 32:
#line 292 "gram.y"
{
			iface->AdvCurHopLimit = yyvsp[-1].num;
		}
break;
case 33:
#line 296 "gram.y"
{
			iface->AdvSourceLLAddress = yyvsp[-1].bool;
		}
break;
case 34:
#line 300 "gram.y"
{
			iface->AdvIntervalOpt = yyvsp[-1].bool;
		}
break;
case 35:
#line 304 "gram.y"
{
			iface->AdvHomeAgentInfo = yyvsp[-1].bool;
		}
break;
case 36:
#line 308 "gram.y"
{
			iface->AdvHomeAgentFlag = yyvsp[-1].bool;
		}
break;
case 37:
#line 312 "gram.y"
{
			iface->HomeAgentPreference = yyvsp[-1].num;
		}
break;
case 38:
#line 316 "gram.y"
{
			iface->HomeAgentLifetime = yyvsp[-1].num;
		}
break;
case 39:
#line 320 "gram.y"
{
			iface->UnicastOnly = yyvsp[-1].bool;
		}
break;
case 40:
#line 324 "gram.y"
{
			iface->AdvMobRtrSupportFlag = yyvsp[-1].bool;
		}
break;
case 41:
#line 330 "gram.y"
{
			yyvsp[-1].pinfo->next = yyvsp[0].pinfo;
			yyval.pinfo = yyvsp[-1].pinfo;
		}
break;
case 42:
#line 337 "gram.y"
{
			unsigned int dst;

			if (prefix->AdvPreferredLifetime >
			    prefix->AdvValidLifetime)
			{
				flog(LOG_ERR, "AdvValidLifeTime must be "
					"greater than AdvPreferredLifetime in %s, line %d", 
					conf_file, num_lines);
				ABORT;
			}

			if( prefix->if6to4[0] )
			{
				if (get_v4addr(prefix->if6to4, &dst) < 0)
				{
					flog(LOG_ERR, "interface %s has no IPv4 addresses, disabling 6to4 prefix", prefix->if6to4 );
					prefix->enabled = 0;
				} else
				{
					*((uint16_t *)(prefix->Prefix.s6_addr)) = htons(0x2002);
					memcpy( prefix->Prefix.s6_addr + 2, &dst, sizeof( dst ) );
				}
			}

			yyval.pinfo = prefix;
			prefix = NULL;
		}
break;
case 43:
#line 368 "gram.y"
{
			struct in6_addr zeroaddr;
			prefix = malloc(sizeof(struct AdvPrefix));
			
			if (prefix == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			prefix_init_defaults(prefix);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			prefix->PrefixLen = yyvsp[0].num;

			memcpy(&prefix->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));

			memset(&zeroaddr, 0, sizeof(zeroaddr));
			if (!memcmp(yyvsp[-2].addr, &zeroaddr, sizeof(struct in6_addr))) {
#ifndef HAVE_IFADDRS_H
				flog(LOG_ERR, "invalid all-zeros prefix in %s, line %d", conf_file, num_lines);
				ABORT;
#else
				dlog(LOG_DEBUG, 5, "all-zeros prefix in %s, line %d, parsing..", conf_file, num_lines);
				struct ifaddrs *ifap, *ifa;
				if (getifaddrs(&ifap) != 0)
					flog(LOG_ERR, "getifaddrs failed: %s", strerror(errno));
			        for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
				        struct sockaddr_in6 *s6;
					char buf[INET6_ADDRSTRLEN];
					if (strncmp(ifa->ifa_name, iface->Name, IFNAMSIZ))
						continue;
                			if (ifa->ifa_addr->sa_family != AF_INET6)
			                        continue;
					s6 = (struct sockaddr_in6 *)(ifa->ifa_addr);
	                		if (IN6_IS_ADDR_LINKLOCAL(&s6->sin6_addr))
						continue;
					if (inet_ntop(ifa->ifa_addr->sa_family, (void *)&(s6->sin6_addr), buf, sizeof(buf)) == NULL) {
						flog(LOG_ERR, "%s: inet_ntop failed in %s, line %d!", ifa->ifa_name, conf_file, num_lines);
					}
					else {
						dlog(LOG_DEBUG, 5, "auto-selected prefix %s on interface %s", buf, ifa->ifa_name);
						memcpy(&prefix->Prefix, &s6->sin6_addr, sizeof(struct in6_addr));
						prefix->AdvRouterAddr=1;
						prefix->AutoSelected=1;
					}
				}
				if (!memcmp(&prefix->Prefix, &zeroaddr, sizeof(struct in6_addr))) {
					prefix->enabled = 0;
					flog(LOG_WARNING, "no auto-selected prefix on interface %s, disabling advertisements",  iface->Name);
				}
				freeifaddrs(ifap);
				freeifaddrs(ifa);
#endif /* ifndef HAVE_IFADDRS_H */
			}
		}
break;
case 48:
#line 439 "gram.y"
{
			prefix->AdvOnLinkFlag = yyvsp[-1].bool;
		}
break;
case 49:
#line 443 "gram.y"
{
			prefix->AdvAutonomousFlag = yyvsp[-1].bool;
		}
break;
case 50:
#line 447 "gram.y"
{
			if (prefix->AutoSelected && yyvsp[-1].bool == 0)
				flog(LOG_WARNING, "prefix automatically selected, AdvRouterAddr always enabled, ignoring config line %d", num_lines);
			else  
				prefix->AdvRouterAddr = yyvsp[-1].bool;
		}
break;
case 51:
#line 454 "gram.y"
{
			prefix->AdvValidLifetime = yyvsp[-1].num;
		}
break;
case 52:
#line 458 "gram.y"
{
			prefix->AdvPreferredLifetime = yyvsp[-1].num;
		}
break;
case 53:
#line 462 "gram.y"
{
			if (prefix->AutoSelected) {
				flog(LOG_ERR, "automatically selecting the prefix and Base6to4Interface are mutually exclusive");
				ABORT;
			} /* fallthrough */
			dlog(LOG_DEBUG, 4, "using interface %s for 6to4", yyvsp[-1].str);
			strncpy(prefix->if6to4, yyvsp[-1].str, IFNAMSIZ-1);
			prefix->if6to4[IFNAMSIZ-1] = '\0';
		}
break;
case 54:
#line 474 "gram.y"
{
			yyvsp[-1].rinfo->next = yyvsp[0].rinfo;
			yyval.rinfo = yyvsp[-1].rinfo;
		}
break;
case 55:
#line 481 "gram.y"
{
			yyval.rinfo = route;
			route = NULL;
		}
break;
case 56:
#line 489 "gram.y"
{
			route = malloc(sizeof(struct AdvRoute));
			
			if (route == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			route_init_defaults(route, iface);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid route prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			route->PrefixLen = yyvsp[0].num;

			memcpy(&route->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));
		}
break;
case 61:
#line 522 "gram.y"
{
			route->AdvRoutePreference = yyvsp[-1].snum;
		}
break;
case 62:
#line 526 "gram.y"
{
			route->AdvRouteLifetime = yyvsp[-1].num;
		}
break;
case 63:
#line 532 "gram.y"
{
			yyvsp[-1].rdnssinfo->next = yyvsp[0].rdnssinfo;
			yyval.rdnssinfo = yyvsp[-1].rdnssinfo;
		}
break;
case 64:
#line 539 "gram.y"
{
			yyval.rdnssinfo = rdnss;
			rdnss = NULL;
		}
break;
case 67:
#line 550 "gram.y"
{
			if (!rdnss) {
				/* first IP found */
				rdnss = malloc(sizeof(struct AdvRDNSS));
				
				if (rdnss == NULL) {
					flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
					ABORT;
				}

				rdnss_init_defaults(rdnss, iface);
			}
			
			switch (rdnss->AdvRDNSSNumber) {
				case 0:
					memcpy(&rdnss->AdvRDNSSAddr1, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 1:
					memcpy(&rdnss->AdvRDNSSAddr2, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 2:
					memcpy(&rdnss->AdvRDNSSAddr3, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				default:
					flog(LOG_CRIT, "Too many addresses in RDNSS section");
					ABORT;
			}
			
		}
break;
case 68:
#line 585 "gram.y"
{
			if (!rdnss) {
				flog(LOG_CRIT, "No address specified in RDNSS section");
				ABORT;
			}
		}
break;
case 73:
#line 603 "gram.y"
{
			rdnss->AdvRDNSSPreference = yyvsp[-1].num;
		}
break;
case 74:
#line 607 "gram.y"
{
			rdnss->AdvRDNSSOpenFlag = yyvsp[-1].bool;
		}
break;
case 75:
#line 611 "gram.y"
{
			if (yyvsp[-1].num < iface->MaxRtrAdvInterval && yyvsp[-1].num != 0) {
				flog(LOG_ERR, "AdvRDNSSLifetime must be at least MaxRtrAdvInterval");
				ABORT;
			}
			if (yyvsp[-1].num > 2*(iface->MaxRtrAdvInterval))
				flog(LOG_WARNING, "Warning: AdvRDNSSLifetime <= 2*MaxRtrAdvInterval would allow stale DNS servers to be deleted faster");

			rdnss->AdvRDNSSLifetime = yyvsp[-1].num;
		}
break;
case 76:
#line 624 "gram.y"
{
                                yyval.num = yyvsp[0].num; 
                        }
break;
case 77:
#line 628 "gram.y"
{
                                yyval.num = (uint32_t)~0;
                        }
break;
#line 1109 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
